/* @clake/react-bootstrap4-window v1.0.8 | by Clake
 * Copyright (c) 2024 Clake,
 * 2024-08-07T17:44:23+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./css/IconButton.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var IconButton =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(IconButton, _React$PureComponent);

  function IconButton(props) {
    var _this;

    _classCallCheck(this, IconButton);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(IconButton).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "dom", void 0);

    return _this;
  }

  _createClass(IconButton, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.dom.addEventListener('mousedown', function (e) {
        e.preventDefault();
        e.stopPropagation();
      }, false);
      this.dom.addEventListener('click', function (e) {
        if (typeof _this2.props.onClick === 'function') {
          _this2.props.onClick(e);
        }
      }, false);
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-icon-button';
      var iconType;

      switch (this.props.iconType) {
        case 'regular':
          iconType = 'far';
          break;

        case 'light':
          iconType = 'fal';
          break;

        case 'brands':
          iconType = 'fab';
          break;

        default:
          iconType = 'fas';
      }

      base = (0, _classnames["default"])(base, iconType, "fa-".concat(this.props.icon));
      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "getStyles",
    value: function getStyles() {
      var base = {};

      if (this.props.color) {
        base.color = this.props.color;
      }

      return base;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return _react["default"].createElement("span", {
        ref: function ref(c) {
          return _this3.dom = c;
        },
        className: this.getClasses(),
        style: this.getStyles()
      });
    }
  }]);

  return IconButton;
}(_react["default"].PureComponent);

var _default = exports["default"] = IconButton;
//# sourceMappingURL=IconButton.js.map
