/* @clake/react-bootstrap4-window v1.0.8 | by Clake
 * Copyright (c) 2024 Clake,
 * 2024-08-07T17:44:23+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactBootstrap = require("@clake/react-bootstrap4");

var _reactDom = _interopRequireDefault(require("react-dom"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var WCalendar =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(WCalendar, _React$PureComponent);

  function WCalendar(props) {
    var _this;

    _classCallCheck(this, WCalendar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(WCalendar).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "event", void 0);

    _defineProperty(_assertThisInitialized(_this), "calDom", void 0);

    _defineProperty(_assertThisInitialized(_this), "calendar", void 0);

    _defineProperty(_assertThisInitialized(_this), "dom", void 0);

    _defineProperty(_assertThisInitialized(_this), "hide", function () {
      _this.dom.classList.add('d-none');
    });

    _defineProperty(_assertThisInitialized(_this), "selectHandler", function (val) {
      if (typeof _this.props.onSelect === 'function') {
        _this.props.onSelect(val, _this.event);
      }
    });

    _this.event = null;
    _this.calDom = null;
    return _this;
  }

  _createClass(WCalendar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.calDom = _reactDom["default"].findDOMNode(this.calendar);
    }
  }, {
    key: "show",
    value: function show(e) {
      var xy = _reactBootstrap.Common.GetDomXY(e.currentTarget); // let fixed = this.calculatePosition(e.currentTarget);


      var positionTop = xy.top + xy.height;
      this.dom.style.left = xy.left + 'px';
      this.dom.classList.remove('d-none');
      this.event = e;
      this.calendar.show(e.currentTarget);

      if (positionTop + this.calDom.offsetHeight < document.documentElement.scrollTop + document.documentElement.clientHeight) {
        positionTop += 5;
      }

      this.dom.style.top = positionTop + 'px';
    }
  }, {
    key: "calculatePosition",
    value: function calculatePosition(e) {
      var scroll = {
        top: e.scrollTop || 0,
        left: e.scrollLeft || 0
      };

      while ((e = e.parentNode) && e !== document.body) {
        if (!e.scrollTop && !e.scrollLeft) continue;
        scroll.top += e.scrollTop;
        scroll.left += e.scrollLeft;
      }

      return scroll;
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-wcombo d-none';
      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "format",
    value: function format() {
      var _this$calendar;

      return (_this$calendar = this.calendar) === null || _this$calendar === void 0 ? void 0 : _this$calendar.format();
    }
  }, {
    key: "setCurrentDate",
    value: function setCurrentDate(d) {
      var _this$calendar2;

      return (_this$calendar2 = this.calendar) === null || _this$calendar2 === void 0 ? void 0 : _this$calendar2.setCurrentDate(d);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var lang = _reactBootstrap.i18n.getLang();

      var content = _react["default"].createElement("div", {
        ref: function ref(c) {
          return _this2.dom = c;
        },
        className: this.getClasses()
      }, _react["default"].createElement(_reactBootstrap.Calendar, {
        ref: function ref(c) {
          return _this2.calendar = c;
        },
        onSelect: this.selectHandler,
        value: this.props.value,
        format: this.props.format,
        lang: lang["short"],
        none: true,
        shadow: true,
        absolute: true,
        triangular: "up",
        sm: true
      }));

      var mainDom = document.getElementById('wcalendar');

      if (!mainDom) {
        mainDom = document.createElement("DIV");
        mainDom.id = 'wcalendar';
        document.body.appendChild(mainDom);
      }

      return _reactDom["default"].createPortal(content, mainDom);
    }
  }]);

  return WCalendar;
}(_react["default"].PureComponent);

var _default = exports["default"] = WCalendar;
//# sourceMappingURL=WCalendar.js.map
