import React from 'react';
import './css/Window.less';
import Drag from './Drag';
import { ComponentProps } from '@clake/react-bootstrap4';
interface Props extends ComponentProps {
    title?: string;
    width?: string;
    height?: string;
    x?: string;
    y?: string;
    backColor?: string;
    name?: string;
    parent?: any;
    marginTop?: any;
    isMaxBtn?: boolean;
    isCloseBtn?: boolean;
    isMinBtn?: boolean;
}
interface State {
    close: boolean;
}
export interface ShowOptions {
    params?: any;
    x?: number;
    y?: number;
}
export declare class Window extends React.PureComponent<Props, State> {
    static EVT_RESIZE: string;
    static EVT_MAXWINDOW: string;
    static EVT_SHOW: string;
    static EVT_CLOSE: string;
    static EVT_BEFORE_CLOSE: string;
    static defaultProps: {
        isCloseBtn: boolean;
        isMaxBtn: boolean;
    };
    parent: any;
    data: any;
    evts: any;
    is_before: boolean;
    is_max: boolean;
    max_position: any;
    drag: Drag | undefined;
    dragDom: HTMLElement;
    domHeader: HTMLElement;
    dom: HTMLElement;
    params: any;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    show(option: ShowOptions): void;
    close: () => void;
    hide: () => void;
    move(x: number, y: number): void;
    max(flag: boolean): void;
    setIndex(index: any): void;
    setActive(active: boolean): void;
    getPosition(): {
        top: number;
        left: number;
        height: number;
        width: number;
    };
    maxHandler: (e: any) => void;
    showHandler: (e: any) => void;
    closeHandler: (e?: any) => void;
    beforeCloseHandler: (e: any) => void;
    on(fn_name: string, fn: any): void;
    off(fn_name: string): void;
    trigger(fn_name: string, val: any): void;
    clearEvent(): void;
    getClasses(): string;
    getStyles(shadow?: boolean): any;
    render(): React.ReactPortal;
    renderContent(): any;
    renderEmpty(): null;
}
export default Window;
//# sourceMappingURL=Window.d.ts.map